javaxp
Automotive
- Jul 14, 2014
- 43
Hi,
I'm trying to make a journal that exports the solid objects on layers 1 and 100 to a new file without parameters. I've finded this thread: Linkthat was very usefull.
My problem is that the resulting geometry on the new part is positionated relative to the original component (the owner of geometry) Absolute Csys, and I need to be positioned relative to the displayed part Absolute Csys. Any clue?
(On the attached example, I need to export the parts 000000_1000_001 and 000000_1500_001. So, select these files and run the code. The 000000_1000_001 file is "out" of the Root Component Absolute Csys, due that it is a "reusable component. The 000000_1500_001 it´s "on" the root component AbsoluteCsys, due that it is designed in context.)
Thanks in advance,
Javier
My code:
NX 12.0.2.9 MP14
I'm trying to make a journal that exports the solid objects on layers 1 and 100 to a new file without parameters. I've finded this thread: Linkthat was very usefull.
My problem is that the resulting geometry on the new part is positionated relative to the original component (the owner of geometry) Absolute Csys, and I need to be positioned relative to the displayed part Absolute Csys. Any clue?
(On the attached example, I need to export the parts 000000_1000_001 and 000000_1500_001. So, select these files and run the code. The 000000_1000_001 file is "out" of the Root Component Absolute Csys, due that it is a "reusable component. The 000000_1500_001 it´s "on" the root component AbsoluteCsys, due that it is designed in context.)
Thanks in advance,
Javier
My code:
Code:
Imports NXOpen
Imports NXOpen.UF
Imports System.Collections.Generic
Imports System
Imports NXOpen.Assemblies
Imports NXOpenUI
Imports System.IO
Imports System.Windows.Forms
Module Module2
Public theSession As Session = Session.GetSession()
Dim s As Session = Session.GetSession()
Dim selobj As NXObject
Dim lw As ListingWindow = s.ListingWindow
'Dim workPart As Part = s.Parts.Work
Dim theUI As UI = UI.GetUI
Dim numsel As Integer = theUI.SelectionManager.GetNumSelectedObjects()
Dim theUISession As UI = UI.GetUI
Dim ufs As UFSession = UFSession.GetUFSession
Dim nError As Integer = 0
Dim origDisplayPart As Part = theSession.Parts.Display
Dim outputFolder As String = ""
Dim partLoadStatus1 As NXOpen.PartLoadStatus = Nothing
Dim dispPart As Part = theSession.Parts.Display
Const bodyLayer1 As Integer = 1
Const bodyLayer100 As Integer = 100
Const curveLayer As Integer = 1
Dim carpeta As String = Nothing
Dim workPart As Part
Dim myComponents As New List(Of Component)()
Dim j As Integer
Sub Main()
lw.Open()
Dim theSession As Session = Session.GetSession()
Dim ufs As UFSession = UFSession.GetUFSession
Dim strPath As String = theSession.Parts.Display.FullPath
Dim strDir As String = IO.Path.GetDirectoryName(strPath)
carpeta = strDir
'lw.WriteFullline("carpeta: " & carpeta)
Dim FolderBrowserDialog1 As New FolderBrowserDialog
' Then use the following code to create the Dialog window
' Change the .SelectedPath property to the default location
With FolderBrowserDialog1
' Desktop is the root folder in the dialog.
.RootFolder = Environment.SpecialFolder.Desktop
'.RootFolder = Environment.SpecialFolder.MyDocuments
'.RootFolder = Environment.SpecialFolder.MyPictures
'.RootFolder = Environment.SpecialFolder.UserProfile
' Select the C:\ directory on entry.
'.SelectedPath = "C:\"
.SelectedPath = carpeta
'.SelectedPath = My.Computer.FileSystem.SpecialDirectories.MyDocuments
'.SelectedPath = My.Computer.FileSystem.SpecialDirectories.Temp
' Prompt the user with a custom message.
.Description = "Selecciona carpeta para guardar DXF de corte"
If .ShowDialog = DialogResult.OK Then
outputFolder = .SelectedPath
Else
'user pressed cancel, exit journal
Exit Sub
End If
End With
If numsel > 0 Then
For inx As Integer = 0 To numsel - 1
Dim myComp As Component
selobj = theUI.SelectionManager.GetSelectedObject(inx)
If TypeOf (selobj) Is Assemblies.Component Then
myComp = CType(selobj, Component)
myComponents.Add(myComp)
End If
Next
For j = 0 To myComponents.Count - 1
Dim partLoadStatus1 As NXOpen.PartLoadStatus = Nothing
theSession.Parts.SetDisplay(myComponents(j).Prototype.OwningPart, True, False, partLoadStatus1)
Dim Nombre_Salida As String
Dim OutputFile As String
'Nombre_Salida = myComponents(j).Prototype.OwningPart.Name
'Nombre_Salida = Nombre_Salida.Replace(" ", "_")
'Dim Material As String
'Material = myComponents(j).GetStringUserAttribute("Material", -1)
'Dim q As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("Q", -1)
'Dim qs As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("QS", -1)
'Dim cantidad As String = "_(" & q & "+" & qs & "S)"
'Nombre_Salida = Nombre_Salida + "_" + Material + cantidad
'OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"
Nombre_Salida = myComponents(j).Prototype.OwningPart.Name & "_" & j.ToString
OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"
exportPart(OutputFile)
Next
theSession.Parts.SetDisplay(origDisplayPart, False, False, partLoadStatus1)
Else
workPart = theSession.Parts.Work
theSession.Parts.SetDisplay(workPart, True, False, partLoadStatus1)
Dim Nombre_Salida As String
Dim OutputFile As String
'Nombre_Salida = myComponents(j).Prototype.OwningPart.Name
'Nombre_Salida = Nombre_Salida.Replace(" ", "_")
'Dim Material As String
'Material = myComponents(j).GetStringUserAttribute("Material", -1)
'Dim q As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("Q", -1)
'Dim qs As Integer = myComponents(j).Prototype.OwningPart.GetIntegerUserAttribute("QS", -1)
'Dim cantidad As String = "_(" & q & "+" & qs & "S)"
'Nombre_Salida = Nombre_Salida + "_" + Material + cantidad
'OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"
Nombre_Salida = myComponents(j).Prototype.OwningPart.Name & "_" & j.ToString
OutputFile = outputFolder & "/" & Nombre_Salida & ".prt"
exportPart(OutputFile)
End If
If nError = 0 Then
theUISession.NXMessageBox.Show("EXPORTACION PRT", NXOpen.NXMessageBox.DialogType.Information, "Se ha realizado la exportación a PRT")
Else
theUISession.NXMessageBox.Show("EXPORTACION PRT", NXOpen.NXMessageBox.DialogType.Error, "NO se ha realizado la exportación a PRT")
End If
End Sub
Sub exportPart(partname)
Dim workPart As Part = theSession.Parts.Work
Dim stateArray1(0) As NXOpen.Layer.StateInfo
stateArray1(0) = New NXOpen.Layer.StateInfo(100, NXOpen.Layer.State.Selectable)
workPart.Layers.ChangeStates(stateArray1, True)
Dim myOptions As UFPart.ExportOptions
myOptions.params_mode = UFPart.ExportParamsMode.RemoveParams
myOptions.new_part = True
Dim objectTags As New List(Of Tag)
For Each myObj As Body In workPart.Bodies
If myObj.Layer = bodyLayer1 Then
objectTags.Add(myObj.Tag)
Else
End If
Next
For Each myObj As Body In workPart.Bodies
If myObj.Layer = bodyLayer100 Then
objectTags.Add(myObj.Tag)
Else
End If
Next
'collect curves
For Each myObj As Curve In workPart.Curves
If myObj.Layer = curveLayer Then
objectTags.Add(myObj.Tag)
End If
Next
If objectTags.Count <> 0 Then
ufs.Part.ExportWithOptions(partname, objectTags.Count, objectTags.ToArray, myOptions)
Else
lw.WriteFullline("Componente: " & partname & " no generado. Generar manualmente ")
End If
End Sub
Public Function GetUnloadOption(ByVal dummy As String) As Integer
Return CInt(NXOpen.Session.LibraryUnloadOption.Immediately)
End Function
End Module
NX 12.0.2.9 MP14